'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Merge3 = require('./_Merge');

var _Merge4 = _interopRequireDefault(_Merge3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Concatenate merge layer class, extends abstract _Merge class
 */
var Concatenate = function (_Merge2) {
  _inherits(Concatenate, _Merge2);

  /**
   * Creates a Concatenate merge layer
   */
  function Concatenate() {
    var attrs = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, Concatenate);

    var _this = _possibleConstructorReturn(this, (Concatenate.__proto__ || Object.getPrototypeOf(Concatenate)).call(this, attrs));

    _this.layerClass = 'Concatenate';

    _this.mode = 'concat';

    var _attrs$axis = attrs.axis,
        axis = _attrs$axis === undefined ? -1 : _attrs$axis;

    // no mini-batch axis here, so we subtract 1 if given axis > 0

    _this.concatAxis = axis <= 0 ? axis : axis - 1;
    return _this;
  }

  return Concatenate;
}(_Merge4.default);

exports.default = Concatenate;